searchNodes=[{"doc":"Base module of the library.","ref":"surreal.html","title":"surreal","type":"module"},{"doc":"Authenticates the current connection with a JWT token.","ref":"surreal.html#authenticate/2","title":"surreal.authenticate/2","type":"function"},{"doc":"Change all records in a table, or a specific record.","ref":"surreal.html#change/3","title":"surreal.change/3","type":"function"},{"doc":"Creates a record in the database.","ref":"surreal.html#create/3","title":"surreal.create/3","type":"function"},{"doc":"Deletes all records in a table, or a specific record, from the database.","ref":"surreal.html#delete/2","title":"surreal.delete/2","type":"function"},{"doc":"Invalidates the authentication for the current connection.","ref":"surreal.html#invalidate/1","title":"surreal.invalidate/1","type":"function"},{"doc":"Applies JSON Patch changes to all records in a table, or a specific record.","ref":"surreal.html#modify/3","title":"surreal.modify/3","type":"function"},{"doc":"Runs a set of SurrealQL statements against the database.","ref":"surreal.html#query/2","title":"surreal.query/2","type":"function"},{"doc":"Runs a set of SurrealQL statements against the database with parameters.","ref":"surreal.html#query/3","title":"surreal.query/3","type":"function"},{"doc":"Selects all records in a table, or a specific record, from the database.","ref":"surreal.html#select/2","title":"surreal.select/2","type":"function"},{"doc":"Signs in to a specific authentication scope.","ref":"surreal.html#signin/3","title":"surreal.signin/3","type":"function"},{"doc":"Signs up to a specific authentication scope.","ref":"surreal.html#signup/6","title":"surreal.signup/6","type":"function"},{"doc":"Same with &quot;start_link&quot; but without linking process.","ref":"surreal.html#start/1","title":"surreal.start/1","type":"function"},{"doc":"Connects to a local or remote database endpoint.","ref":"surreal.html#start_link/1","title":"surreal.start_link/1","type":"function"},{"doc":"Updates all records in a table, or a specific record.","ref":"surreal.html#update/3","title":"surreal.update/3","type":"function"},{"doc":"Switch to a specific namespace and database.","ref":"surreal.html#use/3","title":"surreal.use/3","type":"function"},{"doc":"Module for advanced configs. This module allows you to set configs and use them with calling one function.","ref":"surreal_config.html","title":"surreal_config","type":"module"},{"doc":"Start client from config.","ref":"surreal_config.html#load/1","title":"surreal_config.load/1","type":"function"},{"doc":"","ref":"surreal_config.html#t:config/0","title":"surreal_config.config/0","type":"type"},{"doc":"","ref":"surreal_config.html#t:config_value/0","title":"surreal_config.config_value/0","type":"type"},{"doc":"SurrealDB Client as GenServer. Better not use this GenServer directly but for some cases you may need to use it.","ref":"surreal_gen_server.html","title":"surreal_gen_server","type":"module"},{"doc":"","ref":"surreal_gen_server.html#handle_call/3","title":"surreal_gen_server.handle_call/3","type":"function"},{"doc":"","ref":"surreal_gen_server.html#init/1","title":"surreal_gen_server.init/1","type":"function"},{"doc":"Module for SurrealDB response types and internal functions about it.","ref":"surreal_response.html","title":"surreal_response","type":"module"},{"doc":"","ref":"surreal_response.html#t:response/0","title":"surreal_response.response/0","type":"type"},{"doc":"","ref":"surreal_response.html#t:result/0","title":"surreal_response.result/0","type":"type"},{"doc":"","ref":"surreal_response.html#t:server_error/0","title":"surreal_response.server_error/0","type":"type"},{"doc":"![banner](.github/assets/banner.webp) # SurrealDB Erlang Erlang driver for SurrealDB. Package name named as surreal on hex . Because an Erlang implementation can be used in other languages that runs on BEAM virtual machine, such as Elixir and Gleam. This library tries to be compatible with the official implementation.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Add surreal to your list of dependencies in rebar.config file: { deps , [ { surreal , &quot;1.0.0-beta&quot; } ] } .","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Simple Connection 1 &gt; { ok , Pid } = surreal : start_link ( &quot;ws://localhost:8000&quot; ) . % {ok, &lt;pid&gt;} 2 &gt; surreal : signin ( Pid , &quot;root&quot; , &quot;root&quot; ) . % {ok, null} 3 &gt; surreal : use ( Pid , &quot;test&quot; , &quot;test&quot; ) . % {ok, null} 4 &gt; surreal : create ( Pid , &quot;example:bob&quot; , 4 &gt; \#{ &lt;&lt; &quot;name&quot; &gt;&gt; =&gt; &lt;&lt; &quot;bob&quot; &gt;&gt; } ) . % {ok, \#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;example:bob&quot;&gt;&gt;, &lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;bob&quot;&gt;&gt;}}, 5 &gt; surreal : query ( Pid , &quot;SELECT * FROM type::table($tb);&quot; , 5 &gt; \#{ &lt;&lt; &quot;tb&quot; &gt;&gt; =&gt; &lt;&lt; &quot;test&quot; &gt;&gt; } ) . % [{ok, [\#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;example:bob&quot;&gt;&gt;, &lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;bob&quot;&gt;&gt;}]}] Connect with Config 1 &gt; Config = [ 1 &gt; % link the process 1 &gt; link , 1 &gt; % register local name 1 &gt; { name , example_client } , 1 &gt; % host and port 1 &gt; { host , &quot;localhost&quot; } , 1 &gt; { port , 8000 } , 1 &gt; % database, namespace to use 1 &gt; { use , { &quot;test&quot; , &quot;test&quot; } } , 1 &gt; % user, pass auth 1 &gt; { signin , { &quot;root&quot; , &quot;root&quot; } } 1 &gt; ] . % ... 2 &gt; { ok , Pid } = surreal_config : load ( Config ) . % ... 3 &gt; surreal : create ( example_client , &quot;example:bob&quot; , 3 &gt; \#{ &lt;&lt; &quot;name&quot; &gt;&gt; =&gt; &lt;&lt; &quot;bob&quot; &gt;&gt; } ) . % {ok, \#{&lt;&lt;&quot;id&quot;&gt;&gt; =&gt; &lt;&lt;&quot;example:bob&quot;&gt;&gt;, &lt;&lt;&quot;name&quot;&gt;&gt; =&gt; &lt;&lt;&quot;bob&quot;&gt;&gt;}},","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"Documentation is available at HexDocs .","ref":"readme.html#documentation","title":"README - Documentation","type":"extras"},{"doc":"You can always report bugs and request features via GitHub Issues . For pull requests, make sure your code is well-formatted and at least can explain itself.","ref":"readme.html#contributing","title":"README - Contributing","type":"extras"},{"doc":"SurrealDB Erlang is licensed under the MIT License.","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"Copyright (C) 2023 meppu meppu@proton.me Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"The MIT License","type":"extras"}]